%global pkgver 2.2.14
%global baserelease 3.2

Name:		bluefish
Version:	%{pkgver}
Release:    1%{?dist}
Summary:	Web development application for experienced users
License:	GPL-3.0-or-later
URL:		http://bluefish.openoffice.nl/
Source0:	http://www.bennewitz.com/bluefish/stable/source/bluefish-%{version}%{?prerel:-%{prerel}}.tar.bz2
Patch0:		bluefish-2.2.13-strict-aliasing.patch
Patch1:		bluefish-2.2.12-shellbang.patch
BuildRequires:	coreutils
BuildRequires:	desktop-file-utils
BuildRequires:	enchant-devel >= 1.4.2
BuildRequires:	findutils
BuildRequires:	gcc
BuildRequires:	gettext >= 0.19.7
BuildRequires:	glib2-devel >= 2.24
BuildRequires:	gtk3-devel >= 3.2
BuildRequires:	gucharmap-devel >= 2.90
BuildRequires:	intltool
BuildRequires:	libxml2-devel
BuildRequires:	make
BuildRequires:	python3-devel >= 3.3
BuildRequires:	libappstream-glib >= 0.3.6
BuildRequires:	which
BuildRequires:	/usr/bin/man
Requires:	findutils, grep
Requires:	%{name}-shared-data = %{version}-%{release}

Provides:	bluefish-unstable = %{version}-%{release}

Requires(post): /usr/bin/xmlcatalog, xml-common
Requires(postun): /usr/bin/xmlcatalog, xml-common

%global bluefish_docdir %{?_pkgdocdir}%{!?_pkgdocdir:%{_docdir}/%{name}-%{version}}

%global _python_bytecompile_extra 0

%description
Bluefish is a powerful editor for experienced web designers and programmers.
Bluefish supports many programming and markup languages, but it focuses on
editing dynamic and interactive websites.

%package shared-data
Summary:	Architecture-independent data for %{name}
BuildArch:	noarch
Requires:	%{name} = %{version}-%{release}

Provides:	bluefish-unstable-shared-data = %{version}-%{release}

%description shared-data
Files common to every architecture version of %{name}.

%prep
%setup -q -n %{name}-%{version}%{?prerel:-%{prerel}}

%patch -P 0

%patch -P 1

%build
%configure	--disable-dependency-tracking \
		--disable-static \
		--disable-update-databases \
		--disable-xml-catalog-update \
		--docdir=%{bluefish_docdir}
make %{?_smp_mflags}

%install
mkdir -p %{buildroot}%{_datadir}/applications
make install DESTDIR=%{buildroot} INSTALL="install -p"

find %{buildroot}%{_datadir}/bluefish/plugins/zencoding -name '*.py' |
	xargs awk '/^#!/ { print FILENAME }' |
	xargs chmod -c +x

%find_lang %{name}
%find_lang %{name}_plugin_about
%find_lang %{name}_plugin_charmap
%find_lang %{name}_plugin_entities
%find_lang %{name}_plugin_htmlbar
%find_lang %{name}_plugin_infbrowser
%find_lang %{name}_plugin_snippets
%find_lang %{name}_plugin_zencoding
cat %{name}_plugin_{about,charmap,entities,htmlbar,infbrowser,snippets,zencoding}.lang >> \
	%{name}.lang

appstream-util --nonet validate-relax \
	%{buildroot}%{_datadir}/metainfo/bluefish.appdata.xml

desktop-file-validate \
	%{buildroot}%{_datadir}/applications/bluefish.desktop

install -m 644 -p -t %{buildroot}%{bluefish_docdir}/ \
	AUTHORS ChangeLog README TODO

rm -f %{buildroot}%{_libdir}/bluefish/*.la

%py_byte_compile %{python3} %{buildroot}%{_datadir}/bluefish

%post shared-data
xmlcatalog --noout --add 'delegateURI' \
	'http://bluefish.openoffice.nl/ns/bflang/2.0/' \
	'%{_datadir}/xml/bluefish' \
	%{_sysconfdir}/xml/catalog &> /dev/null || :

%postun shared-data
if [ "$1" = 0 ]; then
	xmlcatalog --noout --del \
		'http://bluefish.openoffice.nl/ns/bflang/2.0/' \
		%{_sysconfdir}/xml/catalog &> /dev/null || :
fi


%files
%license COPYING
%{_bindir}/bluefish
%{_libdir}/bluefish/

%files shared-data -f %{name}.lang
%doc %{bluefish_docdir}/
%{_datadir}/bluefish/
%{_datadir}/metainfo/bluefish.appdata.xml
%{_datadir}/applications/bluefish.desktop
%{_datadir}/mime/packages/bluefish.xml
%{_datadir}/icons/hicolor/*/mimetypes/application-x-bluefish-project.png
%{_datadir}/icons/hicolor/*/apps/bluefish.png
%{_datadir}/icons/hicolor/scalable/mimetypes/bluefish-project.svg
%{_datadir}/icons/hicolor/scalable/apps/bluefish-icon.svg
%{_datadir}/pixmaps/application-x-bluefish-project.png
%{_datadir}/pixmaps/bluefish.png
%{_datadir}/xml/bluefish/
%{_mandir}/man1/bluefish.1*

%changelog
* Fri Jun 28 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.2.14-1
- initial build
